


#include "stdafx.h"
#include <stdlib.h>
#include "mystuff/myglut.h"
#include "mystuff/timer.h"
#include "mystuff/input.h"
#include "mystuff/glmatrix3f.h"

//#include <m3a.h>

#include "mystuff/debug.h"

#include "mystuff/mpc.h"
#include "textureh.h"
#include "entity.h"





#include "sector.h"
#include "world.h"

#include "water.h"
#include "palmtree.h"
#include "sky.h"
#include "sun.h"
#include "dummy.h"
#include "explosion.h"
#include "smallrocket.h"


#include "tanktemplate.h"
#include "camera.h"
#include "spawn.h"
#include "manuscript.h"

#include "texturepainter.h"
#include "world_late.h"


#include "mystuff/fps.h"
#include "mystuff/gltext.h"
#include "raytracer.h"
#include "implementor.h"





void loadstuff()
{
/*	M3o m;
	M3a a;
	m.loadOBJ("data\\models\\WorkShop\\smallrocket");
	m.dumpmaterial("data\\dumps\\m-mat.txt");
	m.dumpdata("data\\dumps\\m.txt");
//	m.flip(1,2);
//	m.flip(0,2);
//	m.multiplyvertex(1.5,1.5,1.5);
//	m.multiplynormal(-1,1,-1);

	a.import(0,&m);
	a.save("data\\models\\smallrocket.m3a");
*/	Mpc mpc;
	mpc.loadbmp4("data\\textures\\alphaball.bmp","data\\textures\\alphaball.bmp",0);
	mpc.save("data\\textures\\alphaball.mpc");
}



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)

{

	int num;

	float detail = 4;


	SDL_Init(SDL_INIT_VIDEO);


	if (MessageBox(NULL,"FullScreen?","Project Akari",MB_YESNO) == IDYES)
		InitGLScreen(800,600,32);
	else InitGLScreen(800,600,32,0);

	Implementor implementor;





	currentworld->setviewdist(40,5);
	currentworld->finalize();


//	loadstuff();



	GLVECTOR3f cpos(200,70,200);
	GLVECTOR3f cdir(0,135,0);
	float cyspeed = 0;
	currentworld->setcameraref(&cpos);
	currentworld->setcameradirref(&cdir);




	glEnable(GL_TEXTURE_2D);
	

	glEnable(GL_FOG);
	glFogi(GL_FOG_MODE,GL_LINEAR);

	GLVECTOR3f fogcol(0.3,0.3,0.3);
	currentworld->setfogcolor(GLVECTOR3f(1,1,1));



	Mpc mpc;

	FPS fps;
	fps.start();
	mpc.loadbmp("data\\textures\\ascii.bmp");
	glText gt;
	GLVECTOR3f fontcolor(1,1,1);
	gt.setup(&fontcolor,mpc.createtexture(0));
	char fpsbuf[10];
	GLVECTOR3f fontpos(-2.5,1.9,0);
	GLVECTOR3f fontpos2(-2.5,1.7,0);
	GLVECTOR3f fontpos3(-2.5,1.5,0);
	GLVECTOR3f fontsize(0.2,0.2,0.2);



	Timer timer;
	timer.settimer(0);

	srand(GetTickCount());
	timer.start();
	float val = 0;


	clearkeys();


	char buf[1024];


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0,0,-2);
	gt.print(&fontpos,&fontsize,"Loading..");
	SDL_GL_SwapBuffers();
	

	implementor.readdirective(9);
	currentworld->render(GL_TRIANGLES);
	int answer = MessageBox(NULL,"This is a very early version of the Akari landscape engine.\nDue to tight schedule, it is not yet fully operational, but it works fine for this early demonstration.\nYou can either view the demo, or control the vehicle yourself.\nDo you want to view the demo?","Project Akari - Demo",MB_YESNOCANCEL);
	if (answer == IDYES)
		implementor.readdirective(6);
	else if (answer == IDNO)
		implementor.readdirective(4);
	else keys[SDLK_ESCAPE] = 1;

	while (!keys[SDLK_ESCAPE])
	{


		glLoadIdentity();

//		glTranslatef(0,0,-20);
//		glRotatef(90,1,0,0);

		glRotatef(currentworld->cameradir->x,1,0,0);
		glRotatef(currentworld->cameradir->y,0,1,0);

		glTranslatef(-currentworld->camerapos->x,-currentworld->camerapos->y,-currentworld->camerapos->z);
	
		
		if (keys[SDLK_SPACE])
		{
			cyspeed = 0.1;
			//cy += 0.1;
		}

		if (keys[SDLK_LEFT])
			cdir.y--;
		if (keys[SDLK_RIGHT])
			cdir.y++;
		if (keys[SDLK_UP])
			cdir.x++;
		if (keys[SDLK_DOWN])
			cdir.x--;

/*		
		for (num = 0; num <= 9; num++)
			if (keys[num+SDLK_0]) 
			{
				implementor.readdirective(num);
				keys[num+SDLK_0] = 0;
			}
*/


		if (keys[SDLK_e])
		{
			cpos.x += sin(0.0174532*cdir.y)*0.3;//*cos(0.0174532*xdir);
			cpos.z -= cos(0.0174532*cdir.y)*0.3;//*cos(0.0174532*xdir);
//			cy -= sin(0.0174532*xdir)*0.1;
		}
		if (keys[SDLK_d])
		{
			cpos.x -= sin(0.0174532*cdir.y)*0.1;//*cos(0.0174532*xdir);
			cpos.z += cos(0.0174532*cdir.y)*0.1;//*cos(0.0174532*xdir);
//			cy += sin(0.0174532*xdir)*0.1;
		}

		val = currentworld->getheight(cpos.x,cpos.z) + 1; 

			cpos.y += cyspeed;
			cyspeed-= 0.002;

		if (cpos.y <= val)
		{
			cpos.y = val;
			cyspeed = 0;
		}
		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


		glEnable(GL_FOG);
		glEnable(GL_TEXTURE_2D);


			if (keys[SDLK_a])		
				currentworld->render(GL_LINE_STRIP);	
			else currentworld->render(GL_TRIANGLES);
/*
		if (keys[SDLK_b])
		{
			sprintf(buf,"%f, %f, %f / %f, %f %f",currentworld->camerapos->x,currentworld->camerapos->y, currentworld->camerapos->z, currentworld->cameradir->x, currentworld->cameradir->y, currentworld->cameradir->z);
			MessageBox(NULL,buf,"Report",MB_OK);
		}
*/

//		if (keys[SDLK_z])
//			currentworld->rendernormals();

		if (keys[SDLK_x])
			currentworld->renderborders();





		glLoadIdentity();
		glTranslatef(0,0,-2);
		glDisable(GL_DEPTH_TEST);

		fps.count();
		itoa(fps.get(),fpsbuf,10);
		gt.print(&fontpos,&fontsize,fpsbuf);
		

		


		glEnable(GL_DEPTH_TEST);



		timer.wait();


		SDL_GL_SwapBuffers();
		

		readmessages();
	}


	SDL_Quit();


	return 0;
}







