#ifndef __IMPLEMENTOR__
#define __IMPLEMENTOR__

#define MAXWORLDS 5

class Implementor
{

public:
	RayTracer rt;

	World *world[MAXWORLDS];
	int currentindex;
	int lastworld; //Made to flag for undo's
	
	ifstream fin;
	char buf[1024];
	char buf2[1024];
	char buf3[1024];
	
	World *newworld(int copyworld = 1);
	World *getworld() {return(currentworld);};		


	void readdirective(int index);

	void error(char *str) {MessageBox(NULL,str,"Implementor Error",MB_OK);};


	//Modifying functions:
	void undo();
	void newmap();
	void settexture();
	void save();
	void load();
	void multvertex();
	
	void loadbump();
	void setsundir();
	void sunlight();
	void traceshadows();



	void makewater(float wlevel);
	void plantpalmtrees();


	TexturePainter tp;

	
	Implementor();
	~Implementor();
};





void Implementor::readdirective(int index)
{
	char filename[100];
	sprintf(filename,"Directives\\directive%i.txt",index);
	fin.open(filename);
	GLVECTOR3f temp;
	float f;
	static EN_Camera *camera;

	if (fin.fail()) 
	{
		error("Corrupt directive file");
		fin.close();
		return;
	}

	while (!fin.eof())
	{
		fin.getline(buf,1024);

		if (!strcmp(buf,"newmap"))
		{
			newmap();
		}
		else if (!strcmp(buf,"loadbump"))
		{
			loadbump();
		}
		else if (!strcmp(buf,"settexture"))
		{
			settexture();
		}
		else if (!strcmp(buf,"undo"))
		{
			undo();
		}
		else if (!strcmp(buf,"load"))
		{
			load();
		}
		else if (!strcmp(buf,"save"))
		{
			save();
		}
		else if (!strcmp(buf,"multvertex"))
		{
			multvertex();
		}
		else if (!strcmp(buf,"finalize"))
		{
			currentworld->finalize();
		}
		else if (!strcmp(buf,"normalizetexcoords"))
		{
			newworld();
			currentworld->normalizetexcoords();
			
		}
		else if (!strcmp(buf,"setsundir"))
		{
			setsundir();
		}
		else if (!strcmp(buf,"sunlight"))
		{
			sunlight();
		}
		else if (!strcmp(buf,"traceshadows"))
		{
			traceshadows();
		}
		else if (!strcmp(buf,"resetpos"))
		{
			currentworld->cameradir->set(0,135,0);
			currentworld->camerapos->set(0,0,0);
			
		}
		else if (!strcmp(buf,"multsundir"))
		{
			fin.getline(buf,1024);
			rt.sundir *= atof(buf);
		}
		else if (!strcmp(buf,"sunambient"))
		{
			fin.getline(buf,1024);
			temp.x = atof(buf);
			fin.getline(buf,1024);
			temp.y = atof(buf);
			fin.getline(buf,1024);
			temp.z = atof(buf);
			rt.ambientcolor = temp;
			newworld();
			rt.settarget(currentworld);
			rt.setambient();
		}
		else if (!strcmp(buf,"setocean"))
		{
			currentworld->deleteentitiesbytype(ENTITY_TYPE_WATER);
			fin.getline(buf,1024);
			f = atof(buf);
			currentworld->finalize();
			makewater(f);
		}
		else if (!strcmp(buf,"plantpalmtrees"))
		{
			plantpalmtrees();
		}
		else if (!strcmp(buf,"clearentities"))
		{
			currentworld->clearentities();
		}
		else if (!strcmp(buf,"startpaint"))
		{
			newworld();
			tp.clear();
			tp.settarget(currentworld);
		}
		else if (!strcmp(buf,"maptexture"))
		{
			fin.getline(buf,1024);
			fin.getline(buf2,1024);
			fin.getline(buf3,1024);
			tp.addtexture(buf,buf2,buf3[0]-'0');
		}
		else if (!strcmp(buf,"endpaint"))
		{
			tp.write();
		}
		else if (!strcmp(buf,"setviewdist"))
		{
			fin.getline(buf,1024);
			fin.getline(buf2,1024);
			currentworld->setviewdist(atof(buf),atof(buf2));
		}
		else if (!strcmp(buf,"saveentities"))
		{
			fin.getline(buf,1024);
			currentworld->saveentities(buf);
		}
		else if (!strcmp(buf,"loadentities"))
		{
			fin.getline(buf,1024);
			currentworld->loadentities(buf);
		}
		else if (!strcmp(buf,"setfogcolor"))
		{
			fin.getline(buf,1024);
			fin.getline(buf2,1024);
			fin.getline(buf3,1024);
			currentworld->setfogcolor(GLVECTOR3f(atof(buf),atof(buf2),atof(buf3)));			
		}
		else if (!strcmp(buf,"createsun"))
		{
			currentworld->deleteentitiesbytype(ENTITY_TYPE_SUN);
			currentworld->deleteentitiesbytype(ENTITY_TYPE_SKY);
			EN_Sky *sky = new EN_Sky;
			currentworld->addentity(sky);
			EN_Sun *sun = new EN_Sun;
			currentworld->addentity(sun);
		}
		else if (!strcmp(buf,"createcamera"))
		{
			camera = new EN_Camera;
//			cam->findnextpalmtree();
			currentworld->addentity(camera);
		}
		else if (!strcmp(buf,"createtank"))
		{
			EN_TankTemplate *t = new EN_TankTemplate;
			t->pos.set(782,90,735);
			currentworld->addentity(t);
			camera->trackpos(&t->pos);
			camera->trackdir(&t->turretturndir);
		}
		else if (!strcmp(buf,"spawn"))
		{
/*			fin.getline(buf,1024);
			EN_Spawn *spawn = new EN_Spawn;
			currentworld->addentity(spawn);
			spawn->execute(ENTITY_TYPE_TANKTEMPLATE,buf);									
*/
			EN_ManuScript *manus = new EN_ManuScript;
			currentworld->addentity(manus);
		}
		else if (!strcmp(buf,""))
		{
		}
		else if (buf[0] == ';')
		{
		}
		else MessageBox(NULL,"Bad directive","",MB_OK);
	}

	fin.close();
}



void Implementor::makewater(float wlevel)
{
	EN_Water *w;
	EN_UnderWaterFader *u = new EN_UnderWaterFader;
	int xnum,ynum;
	Mpc mpc;
	currentworld->waterlevel = wlevel;
	currentworld->addentity(u);
	

	currentworld->deleteentitiesbytype(ENTITY_TYPE_WATER);

	for (ynum = 0; ynum < currentworld->amy; ynum++)
		for (xnum = 0; xnum < currentworld->amx; xnum++)
		{
			w = new EN_Water;
			w->set(0,0,currentworld->xlen,currentworld->ylen,0);
			w->settex((float)xnum*currentworld->xlen*0.1,(float)ynum*currentworld->ylen*0.1,10);
			w->pos.set((float)xnum*currentworld->xlen,wlevel,(float)ynum*currentworld->ylen);
			w->dir.set(0,0,0);
			currentworld->addentity(w);
		}
	

}




void Implementor::plantpalmtrees()
{
	EN_PalmTree *p;
	float x,y,z;
	float xd,yd,zd;
	int num;

	for (num = 0; num < 500; num++)
	{
		x = rand()%(int)(currentworld->amx*currentworld->xlen);
		z = rand()%(int)(currentworld->amy*currentworld->ylen);
		y = currentworld->getheight(x,z);
		if (y < currentworld->waterlevel) { num--; continue; } //Try again
		xd = 0;
		zd = 0;
		yd = (float)(rand()%36000)/100.0f;
		
		p = new EN_PalmTree;
		p->pos.set(x,y,z);
		p->dir.set(xd,yd,zd);
		currentworld->addentity(p);
		

	}


}





void Implementor::sunlight()
{
	newworld();
	currentworld->finalize();
	rt.settarget(currentworld);
	GLVECTOR3f v;
	fin.getline(buf,1024);
	v.x = atof(buf);
	fin.getline(buf,1024);
	v.y = atof(buf);
	fin.getline(buf,1024);
	v.z = atof(buf);
	rt.suncolor = v;
	rt.makesunlight();
}

void Implementor::traceshadows()
{
	newworld();
	currentworld->finalize();
	rt.settarget(currentworld);
	
	GLVECTOR3f sm;
	fin.getline(buf,1024);
	sm.x = atof(buf);
	fin.getline(buf,1024);
	sm.y = atof(buf);
	fin.getline(buf,1024);
	sm.z = atof(buf);
	rt.setshadowmod(sm);

	rt.traceshadows(1);

}


void Implementor::setsundir()
{
	GLVECTOR3f dir;
	fin.getline(buf,1024);
	dir.x = atof(buf);
	fin.getline(buf,1024);
	dir.y = atof(buf);
	fin.getline(buf,1024);
	dir.z = atof(buf);
	rt.setsundir(dir);
	currentworld->sundir = dir;
	currentworld->sundir.normalize();
}


void Implementor::multvertex()
{
	GLVECTOR3f v;
	fin.getline(buf,1024);
	v.x = atof(buf);
	fin.getline(buf,1024);
	v.y = atof(buf);
	fin.getline(buf,1024);
	v.z = atof(buf);
	newworld();
	currentworld->modsectorvertexes(v);
}

void Implementor::save()
{
	fin.getline(buf,1024);
	currentworld->save(buf);
}

void Implementor::load()
{
	newworld(0);
	fin.getline(buf,1024);
	currentworld->load(buf);
	currentworld->finalize();
}


void Implementor::undo()
{
	int s;
	s = currentindex;
	if (currentindex > 0) currentindex--; else currentindex = MAXWORLDS-1;
	if (currentindex == lastworld) currentindex = s;
	currentworld = world[currentindex];
}


void Implementor::settexture()
{
	fin.getline(buf,1024);
	if (fin.eof())
	{
		error("Invalid parameter in settexture");
		return;
	}
	World *w = newworld();
	int index = w->texturehandler.loadbmp(buf);

	if (fin.eof()) 
	{
		error("Settexture: Invalid parameter");
	}


	w->setglobaltexture(w->texturehandler.gettexture(index));
	w->finalize();
	
}

void Implementor::loadbump()
{
	float mul;
	Mpc mpc;
	char file[256];
	fin.getline(file,256);
	if (fin.eof()) 
	{
		error("Missing parameters on loadbump");
		return;
	}
	fin.getline(buf,1024);
	if (fin.eof()) 
	{
		error("Missing parameters on loadbump");
		return;
	}
	mul = atof(buf);
	if (mul == 0) 
	{
		error("Invalid parameters on loadbump");
		return;
	}

	World *w = newworld();
	mpc.loadbmp(file);
	unsigned char *p;
	float *fp;

	p = new unsigned char[mpc.header.xsize*mpc.header.ysize];
	fp = new float[mpc.header.xsize*mpc.header.ysize];

	mpc.dumpplane(0,p);
	int num;
	for (num = 0; num < mpc.header.xsize*mpc.header.ysize; num++)
	{
		fp[num] = (float)p[num]*mul;
	}

	w->setbump(fp,mpc.header.xsize,mpc.header.ysize);
	delete[] p;
	delete[] fp;

}

void Implementor::newmap()
{
	int xsize,ysize,detail,sectorsize;
	fin.getline(buf,1024);
	xsize = atoi(buf);
	fin.getline(buf,1024);
	ysize = atoi(buf);
	fin.getline(buf,1024);
	sectorsize = atoi(buf);
	fin.getline(buf,1024);
	detail = atoi(buf);


	if (!xsize || !ysize || !detail || !sectorsize) 
	{
		error("Invalid parameters for newmap");
		return;
	}
	World *w = newworld(0);
//	w->clear();


	w->create(xsize,ysize,sectorsize,1.0f/detail,1.0f/detail);
	w->finalize();

}






Implementor::Implementor()
{
	currentindex = 0;
	int num;
	for (num = 0; num < MAXWORLDS; num++)
	{
		world[num] = NULL;
	}
	world[0] = new World;
	currentworld = world[0];
}


Implementor::~Implementor()
{
	int num;
	for (num = 0; num < MAXWORLDS; num++)
	{
		if (world[num]) 
		{
			world[num]->clear();
			delete world[num];
		}
	}
}



World *Implementor::newworld(int copyworld)
{
	int num;
	int pw;
	pw = currentindex;

	currentindex = (currentindex+1)%MAXWORLDS;

	if (!world[currentindex]) 
	{
		world[currentindex] = new World;
	}

	if (copyworld)
	{
		world[pw]->clone(world[currentindex]);
	}
	else
	{
//		world[currentindex] = new World;
		world[currentindex] ->clear();
		world[currentindex]->cameradir = world[pw]->cameradir;
		world[currentindex]->camerapos = world[pw]->camerapos;
		world[currentindex]->viewdistance = world[pw]->viewdistance;
	}
	lastworld = currentindex;
	currentworld = world[currentindex];
	return(currentworld);
}


#endif