#ifndef __ENTITY_MANUSCRIPT__
#define __ENTITY_MANUSCRIPT__

class EN_ManuScript : public Entity
{
public:
	char buf[512];
	ifstream fin;
	EN_Camera *camera;
	Entity *index[32];
	DWORD nexttick;
	DWORD starttick;
	virtual int renderme() {return(1);};
	virtual int moveme();
	virtual int init();
	virtual int beforesave() {return(1);}; //Do preparing stuff before saving. (Fill the savebuffer, for example?)
	virtual int afterload() {return(1);};  //Do initializing stuff after loading. Will be called AFTER init();

	void oneof();
	void read();

	void csetpos();
	void csetdir();
	void ctracepos();
	void ctracedir();
	void csettracedelay();
	void createentity();
	void droptofloor();
	void spawn();
	void getfirst();
	void getlast();
	void getnext();
	void getprev();
	void sleep();
	void clookat();
};

void EN_ManuScript::clookat()
{
	camera->trackdir(NULL);
	camera->lookat(&index[atoi(strtok(NULL," "))]->pos);
}

void EN_ManuScript::csettracedelay()
{
	camera->settrackdelay(atoi(strtok(NULL," ")));
}

void EN_ManuScript::csetpos()
{
	camera->trackpos(NULL);
	static GLVECTOR3f temp;
	temp.x = atof(strtok(NULL," "));
	temp.y = atof(strtok(NULL," "));
	temp.z = atof(strtok(NULL," "));
	camera->setpostarget(&temp,atoi(strtok(NULL," ")));
}

void EN_ManuScript::csetdir()
{
	camera->trackdir(NULL);
	static GLVECTOR3f temp;
	temp.x = atof(strtok(NULL," "));
	temp.y = atof(strtok(NULL," "));
	temp.z = atof(strtok(NULL," "));
	camera->setdirtarget(&temp,atoi(strtok(NULL," ")));
}


void EN_ManuScript::ctracepos()
{
	camera->trackpos(&index[atoi(strtok(NULL," "))]->pos);
}

void EN_ManuScript::ctracedir()
{
	camera->trackdir(index[atoi(strtok(NULL," "))]->getcameraref());
}

void EN_ManuScript::createentity()
{
	int i = atoi(strtok(NULL," "));
	Entity *e = currentworld->createentitybytype(atoi(strtok(NULL," ")));
	index[i] = e;
	e->pos.x = atof(strtok(NULL," "));
	e->pos.y = atof(strtok(NULL," "));
	e->pos.z = atof(strtok(NULL," "));
	e->dir.x = atof(strtok(NULL," "));
	e->dir.y = atof(strtok(NULL," "));
	e->dir.z = atof(strtok(NULL," "));
}

void EN_ManuScript::droptofloor()
{
	int i = atoi(strtok(NULL," "));
	index[i]->pos.y = currentworld->getheight(index[i]->pos.x,index[i]->pos.z);
}

void EN_ManuScript::spawn()
{
	int i = atoi(strtok(NULL," "));
	int type = atoi(strtok(NULL," "));
	EN_Spawn *s = new EN_Spawn;
	currentworld->addentity(s);
	s->execute(type,strtok(NULL," "));
	index[i] = s->target;
}

void EN_ManuScript::getfirst()
{
	int num;
	int i = atoi(strtok(NULL," "));
	int type = atoi(strtok(NULL," "));
	for (num = 0; num < currentworld->entities; num++)
		if (currentworld->entity[num]->type == type)
		{
			index[i] = currentworld->entity[num];
			return;
		}
}

void EN_ManuScript::getlast()
{
	int num;
	int i = atoi(strtok(NULL," "));
	int type = atoi(strtok(NULL," "));
	for (num = currentworld->entities-1; num >= 0; num--)
		if (currentworld->entity[num]->type == type)
		{
			index[i] = currentworld->entity[num];
			return;
		}
}

void EN_ManuScript::getnext()
{
	int i = atoi(strtok(NULL," "));
	int num;
	for (num = 0; num < currentworld->entities; num++)
		if (currentworld->entity[num] == index[i]) break;
	if (num >= currentworld->entities) return;
	num++;
	for (; num < currentworld->entities; num++)
		if (currentworld->entity[num]->type == index[i]->type)
		{
			index[i] = currentworld->entity[num];
			return;
		}
}

void EN_ManuScript::getprev()
{
	int i = atoi(strtok(NULL," "));
	int num;
	for (num = currentworld->entities-1; num >= 0; num--)
		if (currentworld->entity[num] == index[i]) break;
	if (num <= 0) return;
	num--;
	for (; num >= 0; num--)
		if (currentworld->entity[num]->type == index[i]->type)
		{
			index[i] = currentworld->entity[num];
			return;
		}
}


void EN_ManuScript::sleep()
{
	nexttick = currentworld->worldTickCount + atoi(strtok(NULL," "));
}



void EN_ManuScript::read()
{
	if (fin.eof()) { oneof(); return;}
	fin.getline(buf,512);
	char *command = strtok(buf," ");
	if (!command) return;
	if (!strcmp(command,"csetpos"))
		csetpos();
	else if (!strcmp(command,"clookat"))
		clookat();
	else if (!strcmp(command,"csetdir"))
		csetdir();
	else if (!strcmp(command,"ctracepos"))
		ctracepos();
	else if (!strcmp(command,"ctracedir"))
		ctracedir();
	else if (!strcmp(command,"csettracedelay"))
		csettracedelay();
	else if (!strcmp(command,"createentity"))
		createentity();
	else if (!strcmp(command,"droptofloor"))
		droptofloor();
	else if (!strcmp(command,"spawn"))
		spawn();
	else if (!strcmp(command,"getfirst"))
		getfirst();
	else if (!strcmp(command,"getlast"))
		getlast();
	else if (!strcmp(command,"getnext"))
		getnext();
	else if (!strcmp(command,"getprev"))
		getprev();
	else if (!strcmp(command,"sleep"))
		sleep();
	else if (!strcmp(command,"quit"))
		keys[SDLK_ESCAPE] = 1;
}


void EN_ManuScript::oneof()
{
	fin.close();
	REMOVEME = 1; //Kill it...
//	keys[SDLK_ESCAPE] = 1;
}

int EN_ManuScript::moveme()
{
	while (currentworld->worldTickCount >= nexttick && !REMOVEME)
		read();
	return(1);
}

int EN_ManuScript::init()
{
	fin.open("data\\manus.txt");
	starttick = currentworld->worldTickCount;
	nexttick = starttick;
	camera = new EN_Camera;
	currentworld->addentity(camera);
	return(1);
}



#endif