#ifndef __GLVECTOR2f__
#define __GLVECTOR2f__


#include <math.h>
/*
	Handles a 2-dimensional vector.
*/



struct GLVECTOR2f
{
	float x,y;
	float len();
	void operator+=(GLVECTOR2f other);
	void operator-=(GLVECTOR2f other);
	void operator*=(float value);
	int operator==(GLVECTOR2f other);
	GLVECTOR2f operator+(GLVECTOR2f other);
	GLVECTOR2f operator-(GLVECTOR2f other);
	GLVECTOR2f(float _x,float _y) {x = _x;y = _y;};
	GLVECTOR2f operator * (float value);
	void operator=(GLVECTOR2f other);
	GLVECTOR2f() {x = 0; y = 0;};
	void set(float _x,float _y);
	float arg();
};

float GLVECTOR2f::arg()
{
	return(atan2(y,x));
}

void GLVECTOR2f::set(float _x,float _y)
{
	x = _x;
	y = _y;
}


float GLVECTOR2f::len()
{
	return(sqrt(x*x+y*y));
}

void GLVECTOR2f::operator *=(float value)
{
	x *= value;
	y *= value;
}

GLVECTOR2f GLVECTOR2f::operator-(GLVECTOR2f other)
{
	return(GLVECTOR2f(x-other.x,y-other.y));	
}

void GLVECTOR2f::operator=(GLVECTOR2f other)
{
	x = other.x;
	y = other.y;
}

int GLVECTOR2f::operator==(GLVECTOR2f other)
{
	return((x == other.x) && (y == other.y));
}


GLVECTOR2f GLVECTOR2f::operator+(GLVECTOR2f other)
{
	return(GLVECTOR2f(x+other.x,y+other.y));
}
GLVECTOR2f GLVECTOR2f::operator*(float value)
{
	return(GLVECTOR2f(x*value,y*value));
}

void GLVECTOR2f::operator +=(GLVECTOR2f other)
{
	x += other.x;
	y += other.y;
//	return
}

void GLVECTOR2f::operator -=(GLVECTOR2f other)
{
	x -= other.x;
	y -= other.y;
}




#endif