#ifndef __GLVECTOR4f__
#define __GLVECTOR4f__


#include "mystuff/GLVECTOR2F.h"
#include "mystuff/GLVECTOR3f.h"
/*
	Handles a 4-dimensional vector.

*/

struct GLVECTOR4f
{
	float x,y,z,a;
	void set(float _x = 0,float _y = 0 ,float _z = 0,float _a = 0);
	void operator+=(GLVECTOR4f other);
	void operator-=(GLVECTOR4f other);
	void operator*=(float value) {x *= value; y *= value; z *= value; a *= value;};
	void operator*=(GLVECTOR4f other) {x *= other.x; y *= other.y; z *= other.z; a *= other.a;};
	int operator==(GLVECTOR4f other);
	GLVECTOR4f operator+(GLVECTOR4f other);
	GLVECTOR4f operator-(GLVECTOR4f other);
	GLVECTOR4f(float _x,float _y,float _z,float _a) {x = _x;y = _y;z = _z;a = _a;};
	GLVECTOR4f operator * (float value);
	void operator=(GLVECTOR4f other);
	void operator=(GLVECTOR2f other);
	void operator=(GLVECTOR3f other);
	GLVECTOR4f() {x = 0; y = 0; z = 0; a = 0;};
	float len();
};


void GLVECTOR4f::set(float _x,float _y,float _z,float _a)
{
	x = _x;
	y = _y;
	z = _z;
	a = _a;
}

float GLVECTOR4f::len()
{
	return(sqrt(x*x+y*y+z*z+a*a));
}

GLVECTOR4f GLVECTOR4f::operator-(GLVECTOR4f other)
{
	return(GLVECTOR4f(x-other.x,y-other.y,z-other.z,a-other.a));	
}

void GLVECTOR4f::operator=(GLVECTOR4f other)
{
	x = other.x;
	y = other.y;
	z = other.z;
	a = other.a;
}
void GLVECTOR4f::operator=(GLVECTOR2f other)
{
	x = other.x;
	y = other.y;
	z = 0;
	a = 0;
}
void GLVECTOR4f::operator=(GLVECTOR3f other)
{
	x = other.x;
	y = other.y;
	z = other.z;
	a = 0;
}

int GLVECTOR4f::operator==(GLVECTOR4f other)
{
	return((x == other.x) && (y == other.y) && (z == other.z) && (a == other.a));
}


GLVECTOR4f GLVECTOR4f::operator+(GLVECTOR4f other)
{
	return(GLVECTOR4f(x+other.x,y+other.y,z+other.z,a+other.a));
}

GLVECTOR4f GLVECTOR4f::operator*(float value)
{
	return(GLVECTOR4f(x*value,y*value,z*value,a*value));
}

void GLVECTOR4f::operator +=(GLVECTOR4f other)
{
	x += other.x;
	y += other.y;
	z += other.z;
	a += other.a;
//	return
}

void GLVECTOR4f::operator -=(GLVECTOR4f other)
{
	x -= other.x;
	y -= other.y;
	z -= other.z;
	a -= other.a;
}







#endif