#ifndef __INPUT__
#define __INPUT__


/*
	Is a tool to manage input controllers such as mouse and keybord.
*/

int mousex = 0;
int mousey = 0;
int rbutton = 0;
int lbutton = 0;
int mbutton = 0;

unsigned char keys[512];


void clearkeys()
{
	int num;
	for (num = 0; num < 512; num++)
		keys[num] = 0;
}



void readmessages()
{
	static SDL_Event event;

	while (SDL_PollEvent(&event))
	{
		switch(event.type)
		{
		case SDL_KEYDOWN:
			keys[event.key.keysym.sym] = 1;
		break;
		case SDL_KEYUP:
			keys[event.key.keysym.sym] = 0;
		break;
		case SDL_MOUSEMOTION:
			mousex = event.motion.x;
			mousey = event.motion.y;
		break;
		case SDL_MOUSEBUTTONDOWN:
			if (event.button.button == SDL_BUTTON_LEFT)
				lbutton = 1;
			else if (event.button.button == SDL_BUTTON_RIGHT)
				rbutton = 1;
			else mbutton = 1;
		break;
		case SDL_MOUSEBUTTONUP:
			if (event.button.button == SDL_BUTTON_LEFT)
				lbutton = 0;
			else if (event.button.button == SDL_BUTTON_RIGHT)
				rbutton = 0;
			else mbutton = 0;
		break;
		}
	}

}



#endif