#ifndef __MYGLUT__
#define __MYGLUT__


#include "sdl/SDL.h"

#include "sdl/SDL_opengl.h"
#include <GL/gl.h>
#include <GL/glu.h>

#include <math.h>

//#define LPCTSTR char*
//#define WORD int
//#define DWORD int
//#define MB_OK 0
//#define MessageBox(a, b, c, d) printf("MsgBox: %s\n", b)

/* Various global variables 
*/
SDL_Surface *mainscreen;
const SDL_VideoInfo *vinfo;
 

#include "mystuff/glvector2f.h"
#include "mystuff/glvector3f.h"















struct GLRECTf
{
	float left,top,right,bottom;
};


inline int InitGLScreen(int width,int height,int bpp,DWORD flags = SDL_FULLSCREEN)
{
	flags = flags | SDL_OPENGL;

	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 32 );
//	SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
//	SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE,8);
	vinfo = SDL_GetVideoInfo();
	if ( (mainscreen=SDL_SetVideoMode( width, height, bpp, flags)) == NULL ) {
	fprintf(stderr, "Couldn't set GL mode: %s\n", SDL_GetError());
	SDL_Quit();
	return 0;
	}
/*	int temp;
	SDL_GL_GetAttribute(SDL_GL_ALPHA_SIZE,&temp);
	if (!temp)
		MessageBox(NULL,"Cannot setup alpha buffer!","",MB_OK);
*/
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations
//	return TRUE;	


	glViewport(0,0,width,height);						// Reset The Current Viewport
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	// Calculate The Aspect Ratio Of The Window
	gluPerspective(90.0f,(GLfloat)width/(GLfloat)height,0.1f,1000.0f);
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix

	return(1);
}


	
GLuint LoadGLTexture(LPCTSTR filename,char filtertype)
{ 
	GLuint texture;
	SDL_Surface *bmp;

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit

	if (bmp = SDL_LoadBMP(filename))
	{



		glGenTextures(1, &texture);					// Create Three Textures

		SDL_LockSurface(bmp);

		if (bmp->format->BitsPerPixel != 24)
			MessageBox(NULL,"FEEL!","",MB_OK);
		
		if (!filtertype)
		{
		// Create Nearest Filtered Texture
			glBindTexture(GL_TEXTURE_2D, texture);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, bmp->w, bmp->h, 0, GL_RGB, GL_UNSIGNED_BYTE, (unsigned char*)bmp->pixels);
		}
		if (filtertype == 1)
		{
		// Create Linear Filtered Texture
			glBindTexture(GL_TEXTURE_2D, texture);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, bmp->w,bmp->h, 0, GL_RGB, GL_UNSIGNED_BYTE, (unsigned char*)bmp->pixels);
		}
		if (filtertype == 2)
		{
		// Create MipMapped Texture
			glBindTexture(GL_TEXTURE_2D, texture);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, bmp->w,bmp->h, GL_RGB, GL_UNSIGNED_BYTE, bmp->pixels);
		}
		SDL_UnlockSurface(bmp);

		SDL_FreeSurface(bmp);
		return(texture);

	}
	else MessageBox(NULL,"Cannot load Texture","MSG",MB_OK);

	return(0);

}




#endif
