#ifndef __ENTITY_SUN__
#define __ENTITY_SUN__

#define ENTITY_TYPE_SUN 4


class EN_Sun : public Entity
{
public:
	GLuint texture;
	GLVECTOR3f sunangle;

	int afterload() {return(1);};
	int beforesave() {return(1);};
	int renderme();
	int init();
	EN_Sun() {homesector = ENTITY_STATIC; type = ENTITY_TYPE_SUN;};
};


int EN_Sun::init()
{
	sunangle.x = acos(sqrt(pow(currentworld->sundir.x,2)+pow(currentworld->sundir.z,2)))*360.0f/6.28318;
	sunangle.y = 180 + atan2(currentworld->sundir.x,currentworld->sundir.z)*360.0f/6.28318;

	texture = currentworld->texturehandler.gettexture(currentworld->texturehandler.load("data\\textures\\sun.mpc",2));
	

	return(1);
}

int EN_Sun::renderme()
{
	float EN_SUN_SIZE = 400;
	GLVECTOR3f cameradir;

	glDisable(GL_FOG);
	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glBindTexture(GL_TEXTURE_2D,texture);
	glColor3f(1,1,0.1);
	glPushMatrix();

	glLoadIdentity();

	glRotatef(sunangle.x+currentworld->cameradir->x,1,0,0);	
	glRotatef(sunangle.y+currentworld->cameradir->y,0,1,0);	


	glTranslatef(0,0,-600);


	cameradir.x = sin(0.0174532*currentworld->cameradir->y)*cos(0.0174532*currentworld->cameradir->x);
	cameradir.z = -cos(0.0174532*currentworld->cameradir->y)*cos(0.0174532*currentworld->cameradir->x);
	cameradir.y = -sin(0.0174532*currentworld->cameradir->x);


	cameradir.normalize();

	cameradir *= currentworld->sundir;



	float angle = acos(cameradir.x+cameradir.y+cameradir.z);
	angle = fabs(angle);
	


#define ANGLEBORDER 1




	glBegin(GL_QUADS);

		glTexCoord2f(0,0);
		glVertex3f(-EN_SUN_SIZE,-EN_SUN_SIZE,0);
		glTexCoord2f(1,0);
		glVertex3f(EN_SUN_SIZE,-EN_SUN_SIZE,0);
		glTexCoord2f(1,1);
		glVertex3f(EN_SUN_SIZE,EN_SUN_SIZE,0);
		glTexCoord2f(0,1);
		glVertex3f(-EN_SUN_SIZE,EN_SUN_SIZE,0);

	glEnd();

/*
	if (angle < ANGLEBORDER)
	{
		cameradir = currentworld->fogcolor;
		cameradir.x += ANGLEBORDER-angle;
		cameradir.y += ANGLEBORDER-angle;
		cameradir.z += ANGLEBORDER-angle;
		glFogfv(GL_FOG_COLOR,(float*)&cameradir);
		glClearColor(cameradir.x,cameradir.y,cameradir.z,1);

		glFogf(GL_FOG_START,(angle/ANGLEBORDER)*(currentworld->save_viewdistance-currentworld->save_viewdifflen));
		glFogf(GL_FOG_END,(angle/ANGLEBORDER)*currentworld->save_viewdistance);
	}
	else
	{
		glFogfv(GL_FOG_COLOR,(float*)&currentworld->fogcolor);
		glClearColor(currentworld->fogcolor.x,currentworld->fogcolor.y,currentworld->fogcolor.z,1);
		glFogf(GL_FOG_START,currentworld->save_viewdistance-currentworld->save_viewdifflen);
		glFogf(GL_FOG_END,currentworld->save_viewdistance);
	}
*/
	if (angle < ANGLEBORDER)
	{
		glColor4f(1,1,1,0.7-angle/ANGLEBORDER);
		glLoadIdentity();
		glDisable(GL_DEPTH_TEST);
		glTranslatef(0,0,-1);
		glDisable(GL_TEXTURE_2D);
		glBegin(GL_QUADS);
			glVertex3f(-2,1,0);
			glVertex3f(2,1,0);
			glVertex3f(2,-1,0);
			glVertex3f(-2,-1,0);
		glEnd();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_DEPTH_TEST);
	}



	glDepthMask(GL_TRUE);
	glPopMatrix();
	glDisable(GL_BLEND);
	glEnable(GL_FOG);


	return(1);
}


#endif