#ifndef __ENTITY_TANK01__
#define __ENTITY_TANK01__

#define ENTITY_TYPE_TANKTEMPLATE 7

#include "tank01turret.h"

class EN_TankTemplate_Foot : public Entity
{
	int renderme() {return(defaultrender());};
	int moveme() {return(1);};
	int init();

	int beforesave() {return(1);}; //Do preparing stuff before saving. (Fill the savebuffer, for example?)
	int afterload() {return(1);};  //Do initializing stuff after loading. Will be called AFTER init();
};




class EN_TankTemplate : public Entity
{
public:

	EN_TankTemplate_Foot *foot[2];
	EN_TankTemplate_Turret *turret;
	
	
	GLVECTOR3f olddir;
	GLVECTOR3f targetdir;
	GLVECTOR3f targetdiffdir;
	GLVECTOR3f oldpos;
	GLVECTOR3f targetpos;
	GLVECTOR3f targetdiffpos;
	GLVECTOR3f posforce;
	GLVECTOR3f dirforce;
	float bodyheight;
	int isinair;
	DWORD nextmove;
	int movedelay;



	GLVECTOR3f turretdir;
	GLVECTOR3f turretturndir;
	GLVECTOR3f cameradir;

	void calcforces();


	int renderme();
	int moveme();
	int init();

	int beforesave() {return(1);}; //Do preparing stuff before saving. (Fill the savebuffer, for example?)
	int afterload() {return(1);};  //Do initializing stuff after loading. Will be called AFTER init();
	EN_TankTemplate() {type = ENTITY_TYPE_TANKTEMPLATE;}
};


void EN_TankTemplate::calcforces()
{
	int num;
	GLVECTOR3f temp,temp2,angle;
	GLVECTOR3f *v;
	GLfloat matrix[16];
	GLfloat invmatrix[16];
	GLfloat invmatrix2[16];

	static float centerpoint, rightpoint, forwardpoint;
	static float bumpheight = 0;
	static float bumpelaps = 0;

	M3o *m = &model[0]->model[0];
	
	glPushMatrix();
	glLoadIdentity();
	glRotatef(dir.y,0,1,0);
	glRotatef(dir.x,1,0,0);
	glRotatef(dir.z,0,0,1);
	glGetFloatv(GL_MODELVIEW_MATRIX,matrix);	
	glLoadIdentity();
	glRotatef(-dir.z,0,0,1);
	glRotatef(-dir.x,1,0,0);
	glRotatef(-dir.y,0,1,0);
	glGetFloatv(GL_MODELVIEW_MATRIX,invmatrix);	
	glLoadIdentity();
	glRotatef(-dir.y,0,1,0);
	glRotatef(-dir.x,1,0,0);
	glRotatef(-dir.z,0,0,1);
	glGetFloatv(GL_MODELVIEW_MATRIX,invmatrix2);	


/*
		temp.x = matrix[0]*v->x + matrix[1]*v->y + matrix[2]*v->z;
		temp.y = matrix[4]*v->x + matrix[5]*v->y + matrix[6]*v->z;
		temp.z = matrix[8]*v->x + matrix[9]*v->y + matrix[10]*v->z;
*/



	posforce = targetpos-oldpos;

	centerpoint = currentworld->getheight(pos.x,pos.z);


	temp.x = matrix[0]*2.0f;
	temp.y = matrix[4]*2.0f;
	temp.z = matrix[8]*2.0f;
	rightpoint = currentworld->getheight(targetpos.x+temp.x,targetpos.z+temp.z);

	temp2.x = matrix[2]*-2;
	temp2.y = matrix[6]*-2;
	temp2.z = matrix[10]*-2;
	forwardpoint = currentworld->getheight(targetpos.x+temp2.x,targetpos.z+temp2.z);

	//dirforce.z = atan2(rightpoint-centerpoint,2);
	if (centerpoint + bodyheight < targetpos.y)
	{
		isinair = 1;
		posforce.y -= 0.01; //Gravity
	}
	else
	{
		if (isinair) //Was previously in air
		{
			bumpheight = centerpoint + bodyheight - targetpos.y;
			bumpheight *= 2;
		}

		bumpheight -= 0.01;
		if (bumpheight < 0) bumpheight = 0;

		isinair = 0;
		

		targetpos.y = centerpoint + bodyheight - bumpheight;
		posforce = targetpos-oldpos;

	

	}
	


		temp.x = atan2(centerpoint-forwardpoint,2.0f)*57.29577f;
		temp.z = atan2(centerpoint-rightpoint,2.0f)*57.29577f;


		if (temp.x-dir.x > 30) 
		{
			dir.x = temp.x - 30;
		}
		if (temp.x-dir.x < -30)
		{
			dir.x = temp.x + 30;
		}
	
		if (temp.z-dir.z > 10) 
		{
			dir.z = temp.z - 10;
		}
		if (temp.z-dir.z < -10)
		{
			dir.z = temp.z + 10;
		}


		dirforce.x += (temp.x-dir.x) / 100.0f;
		dirforce.z += (temp.z-dir.z) / 100.0f;

		dirforce *= 0.95; 
		dirforce.z *= 0.9;
	



	if (isinair)
	{


	}
	else
	{

		dirforce.y *= 0.3;


		temp.x = invmatrix[0]*posforce.x + invmatrix[1]*posforce.y + invmatrix[2]*posforce.z;
		temp.y = invmatrix[4]*posforce.x + invmatrix[5]*posforce.y + invmatrix[6]*posforce.z;
		temp.z = invmatrix[8]*posforce.x + invmatrix[9]*posforce.y + invmatrix[10]*posforce.z;
		
		temp2.x = temp.x;
		temp.x *= 0.9;
		temp.z *= 0.99;

		temp2.x -= temp.x;
		dirforce.z += temp2.x*20;

		if (keys[SDLK_e])
		{
			if (temp.z < 0) //Going forward
			{
			dirforce.x += 0.003/(temp.z-0.003);
			}
			else //reverse
			{
				dirforce.x -= 0.1;
			}
//			temp.z -= 0.003;

		}
		if (keys[SDLK_d])
		{
			if (temp.z > 0) //Going forward
			{
				dirforce.x -= 0.003/(-fabs(temp.z)-0.003);
			}
			else //reverse
			{
				dirforce.x += 0.1;
			}
//			temp.z += 0.003;
		}

		posforce.x = matrix[0]*temp.x + matrix[1]*temp.y + matrix[2]*temp.z;
		posforce.y = matrix[4]*temp.x + matrix[5]*temp.y + matrix[6]*temp.z;
		posforce.z = matrix[8]*temp.x + matrix[9]*temp.y + matrix[10]*temp.z;
	
		if (keys[SDLK_e])
		{
			posforce.x += sin(0.0174532*dir.y)*0.003;//*cos(0.0174532*xdir);
			posforce.z -= cos(0.0174532*dir.y)*0.003;//*cos(0.0174532*xdir);
		}
		if (keys[SDLK_d])
		{
			posforce.x -= sin(0.0174532*dir.y)*0.003;//*cos(0.0174532*xdir);
			posforce.z += cos(0.0174532*dir.y)*0.003;//*cos(0.0174532*xdir);
		}



		if (keys[SDLK_s])
			dirforce.y -= 2;
		if (keys[SDLK_f])
			dirforce.y += 2;
	}


	if (pos.y < currentworld->waterlevel-bodyheight/2.0f) 
	{
		posforce *= 0.8;
		dirforce *= 0.5;
	}




	oldpos = targetpos;
	olddir = targetdir;
	targetpos += posforce;
	targetdir += dirforce;

	targetdiffpos = targetpos - oldpos;
	targetdiffdir = targetdir - olddir;



	if (keys[SDLK_LEFT])
		turretturndir.y -= 3;
	if (keys[SDLK_RIGHT])
		turretturndir.y += 3;
	if (keys[SDLK_UP])
		turretturndir.x += 2;
	if (keys[SDLK_DOWN])
		turretturndir.x -= 2;

	//GYRO
	currentworld->a2v(&turretturndir,&temp2);
	temp2 *= -1;

	
	temp.x = invmatrix2[0]*temp2.x + invmatrix2[1]*temp2.y + invmatrix2[2]*temp2.z;
	temp.y = invmatrix2[4]*temp2.x + invmatrix2[5]*temp2.y + invmatrix2[6]*temp2.z;
	temp.z = invmatrix2[8]*temp2.x + invmatrix2[9]*temp2.y + invmatrix2[10]*temp2.z;

	temp.normalize();
	currentworld->v2a(&temp);

	turretdir = temp;
	//END GYRO


	if (keys[SDLK_o])
	{
		keys[SDLK_o] = 0;
		startrecord("data\\records\\testrecord.rec",currentworld->worldTickCount,200);
	}
	if (keys[SDLK_p])
	{
		keys[SDLK_p] = 0;
		endrecord();
	}
	if (keys[SDLK_l])
	{
		keys[SDLK_l] = 0;
		play("data\\records\\testrecord.rec",currentworld->worldTickCount);
	}



//	cameradir = turretturndir;

	glPopMatrix();

}




int EN_TankTemplate::renderme()
{

	return(defaultrender());
}















int EN_TankTemplate::moveme()
{
//	pos.y -= 0.06;
	while (currentworld->worldTickCount >= nextmove)
	{
		calcforces();
		if (nextmove == 0) nextmove = currentworld->worldTickCount;
		nextmove += movedelay;
	}

	float elaps;
	elaps = (float)(currentworld->worldTickCount - nextmove+movedelay)/(float)movedelay;
	if (elaps > 1 || elaps < 0)
		MessageBox(NULL,"Wrong elaps","",MB_OK);
	pos = oldpos + targetdiffpos*elaps;
	dir = olddir + targetdiffdir*elaps;



	return(1);
}


int EN_TankTemplate::init()
{
	M3a *m = new M3a;
	m->load("data\\models\\tank01Body.m3a");

	int num;

	addrecorddata(&turretturndir,1);
	addrecorddata(&turretdir,1);



	bodyheight = 1;

	oldpos = pos;
	olddir = dir;
	targetpos = pos;
	targetdir = dir;


	model[0] = m;
	nextmove = 0;
	movedelay = 20;

	foot[0] = new EN_TankTemplate_Foot;
	foot[0]->pos.set(-0.7,-0.5,0);
	addchild(foot[0]);	
	foot[1] = new EN_TankTemplate_Foot;
	foot[1]->pos.set(0.7,-0.5,0);
	addchild(foot[1]);	

	turret = new EN_TankTemplate_Turret;
	turret->pos.set(0,0.5,0.3);
	turret->targetdir = &turretdir;
	addchild(turret);

	


	return(1);
}



/* FOOT FUNCTIONS */

int EN_TankTemplate_Foot::init()
{
	M3a *m = new M3a;
	m->load("data\\models\\tank01Foot.m3a");
	model[0] = m;
	return(1);
}



#endif